Loading...
Searching...
No Matches
irr::scene::IBillboardSceneNode Class Referenceabstract

A billboard scene node. More...

`#include <IBillboardSceneNode.h>`

Inheritance diagram for irr::scene::IBillboardSceneNode:

## Public Member Functions

| IBillboardSceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id, const core::vector3df &position=core::vector3df(0, 0, 0))
| Constructor.
virtual void | getColor (video::SColor &topColor, video::SColor &bottomColor) const =0
| Gets the color of the top and bottom vertices of the billboard.
virtual const core::dimension2d< f32 > & | getSize () const =0
| Returns the size of the billboard.
virtual void | getSize (f32 &height, f32 &bottomEdgeWidth, f32 &topEdgeWidth) const =0
| Gets the size of the the billboard and handles independent top and bottom edge widths correctly.
virtual void | setColor (const video::SColor &overallColor)=0
| Set the color of all vertices of the billboard.
virtual void | setColor (const video::SColor &topColor, const video::SColor &bottomColor)=0
| Set the color of the top and bottom vertices of the billboard.
virtual void | setSize (const core::dimension2d< f32 > &size)=0
| Sets the size of the billboard, making it rectangular.
virtual void | setSize (f32 height, f32 bottomEdgeWidth, f32 topEdgeWidth)=0
| Sets the size of the billboard with independent widths of the bottom and top edges.
Public Member Functions inherited from irr::scene::ISceneNode
| ISceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id=-1, const core::vector3df &position=core::vector3df(0, 0, 0), const core::vector3df &rotation=core::vector3df(0, 0, 0), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual | ~ISceneNode ()
| Destructor.
virtual void | addAnimator (ISceneNodeAnimator *animator)
| Adds an animator which should animate this node.
virtual void | addChild (ISceneNode *child)
| Adds a child to this scene node.
virtual ISceneNode * | clone (ISceneNode *newParent=0, ISceneManager *newManager=0)
| Creates a clone of this scene node and its children.
virtual void | deserializeAttributes (io::IAttributes *in, io::SAttributeReadWriteOptions *options=0)
| Reads attributes of the scene node.
virtual core::vector3df | getAbsolutePosition () const
| Gets the absolute position of the node in world coordinates.
virtual const core::matrix4 & | getAbsoluteTransformation () const
| Get the absolute transformation of the node. Is recalculated every OnAnimate()-call.
const core::list< ISceneNodeAnimator * > & | getAnimators () const
| Get a list of all scene node animators.
u32 | getAutomaticCulling () const
| Gets the automatic culling state.
virtual const core::aabbox3d< f32 > & | getBoundingBox () const =0
| Get the axis aligned, not transformed bounding box of this node.
const core::list< ISceneNode * > & | getChildren () const
| Returns a const reference to the list of all children.
virtual s32 | getID () const
| Get the id of the scene node.
virtual video::SMaterial & | getMaterial (u32 num)
| Returns the material based on the zero based index i.
virtual u32 | getMaterialCount () const
| Get amount of materials used by this scene node.
virtual const c8 * | getName () const
| Returns the name of the node.
scene::ISceneNode * | getParent () const
| Returns the parent of this scene node.
virtual const core::vector3df & | getPosition () const
| Gets the position of the node relative to its parent.
virtual core::matrix4 | getRelativeTransformation () const
| Returns the relative transformation of the scene node.
virtual const core::vector3df & | getRotation () const
| Gets the rotation of the node relative to its parent.
virtual const core::vector3df & | getScale () const
| Gets the scale of the scene node relative to its parent.
virtual ISceneManager * | getSceneManager (void) const
| Retrieve the scene manager for this node.
virtual const core::aabbox3d< f32 > | getTransformedBoundingBox () const
| Get the axis aligned, transformed and animated absolute bounding box of this node.
virtual ITriangleSelector * | getTriangleSelector () const
| Returns the triangle selector attached to this scene node.
virtual ESCENE_NODE_TYPE | getType () const
| Returns type of the scene node.
u32 | isDebugDataVisible () const
| Returns if debug data like bounding boxes are drawn.
bool | isDebugObject () const
| Returns if this scene node is a debug object.
virtual bool | isTrulyVisible () const
| Check whether the node is truly visible, taking into accounts its parents' visibility.
virtual bool | isVisible () const
| Returns whether the node should be visible (if all of its parents are visible).
virtual void | OnAnimate (u32 timeMs)
| OnAnimate() is called just before rendering the whole scene.
virtual void | OnRegisterSceneNode ()
| This method is called just before the rendering process of the whole scene.
virtual void | remove ()
| Removes this scene node from the scene.
virtual void | removeAll ()
| Removes all children of this scene node.
virtual void | removeAnimator (ISceneNodeAnimator *animator)
| Removes an animator from this scene node.
virtual void | removeAnimators ()
| Removes all animators from this scene node.
virtual bool | removeChild (ISceneNode *child)
| Removes a child from this scene node.
virtual void | render ()=0
| Renders the node.
virtual void | serializeAttributes (io::IAttributes *out, io::SAttributeReadWriteOptions *options=0) const
| Writes attributes of the scene node.
void | setAutomaticCulling (u32 state)
| Enables or disables automatic culling based on the bounding box.
virtual void | setDebugDataVisible (u32 state)
| Sets if debug data like bounding boxes should be drawn.
virtual void | setID (s32 id)
| Sets the id of the scene node.
void | setIsDebugObject (bool debugObject)
| Sets if this scene node is a debug object.
void | setMaterialFlag (video::E_MATERIAL_FLAG flag, bool newvalue)
| Sets all material flags at once to a new value.
void | setMaterialTexture (u32 textureLayer, video::ITexture *texture)
| Sets the texture of the specified layer in all materials of this scene node to the new texture.
void | setMaterialType (video::E_MATERIAL_TYPE newType)
| Sets the material type of all materials in this scene node to a new material type.
virtual void | setName (const c8 *name)
| Sets the name of the node.
virtual void | setName (const core::stringc &name)
| Sets the name of the node.
virtual void | setParent (ISceneNode *newParent)
| Changes the parent of the scene node.
virtual void | setPosition (const core::vector3df &newpos)
| Sets the position of the node relative to its parent.
virtual void | setRotation (const core::vector3df &rotation)
| Sets the rotation of the node relative to its parent.
virtual void | setScale (const core::vector3df &scale)
| Sets the relative scale of the scene node.
virtual void | setTriangleSelector (ITriangleSelector *selector)
| Sets the triangle selector of the scene node.
virtual void | setVisible (bool isVisible)
| Sets if the node should be visible or not.
virtual void | updateAbsolutePosition ()
| Updates the absolute position based on the relative and the parents position.
Public Member Functions inherited from irr::IReferenceCounted
| IReferenceCounted ()
| Constructor.
virtual | ~IReferenceCounted ()
| Destructor.
bool | drop () const
| Drops the object. Decrements the reference counter by one.
const c8 * | getDebugName () const
| Returns the debug name of the object.
s32 | getReferenceCount () const
| Get the reference count.
void | grab () const
| Grabs the object. Increments the reference counter by one.

## Additional Inherited Members

Protected Member Functions inherited from irr::scene::ISceneNode
void | cloneMembers (ISceneNode *toCopyFrom, ISceneManager *newManager)
| A clone function for the ISceneNode members.
void | setSceneManager (ISceneManager *newManager)
Protected Member Functions inherited from irr::IReferenceCounted
void | setDebugName (const c8 *newName)
| Sets the debug name of the object.
Protected Attributes inherited from irr::scene::ISceneNode
core::matrix4 | AbsoluteTransformation
| Absolute transformation of the node.
core::list< ISceneNodeAnimator * > | Animators
| List of all animator nodes.
u32 | AutomaticCullingState
| Automatic culling state.
core::list< ISceneNode * > | Children
| List of all children of this node.
u32 | DebugDataVisible
| Flag if debug data should be drawn, such as Bounding Boxes.
s32 | ID
| ID of the node.
bool | IsDebugObject
| Is debug object?
bool | IsVisible
| Is the node visible?
core::stringc | Name
| Name of the scene node.
ISceneNode * | Parent
| Pointer to the parent.
core::vector3df | RelativeRotation
| Relative rotation of the scene node.
core::vector3df | RelativeScale
| Relative scale of the scene node.
core::vector3df | RelativeTranslation
| Relative translation of the scene node.
ISceneManager * | SceneManager
| Pointer to the scene manager.
ITriangleSelector * | TriangleSelector
| Pointer to the triangle selector.

## Detailed Description

A billboard scene node.

A billboard is like a 3d sprite: A 2d element, which always looks to the camera. It is usually used for explosions, fire, lensflares, particles and things like that.

Definition at line 20 of file IBillboardSceneNode.h.

## Constructor & Destructor Documentation

## IBillboardSceneNode()

irr::scene::IBillboardSceneNode::IBillboardSceneNode | ( | ISceneNode * | parent,
|  | ISceneManager * | mgr,
|  | s32 | id,
|  | const core::vector3df & | position = core::vector3df(0,0,0) )

inline

Constructor.

Definition at line 25 of file IBillboardSceneNode.h.

References irr::scene::ISceneNode::ISceneNode().

Referenced by irr::scene::IBillboardTextSceneNode::IBillboardTextSceneNode().

## Member Function Documentation

## getColor()

virtual void irr::scene::IBillboardSceneNode::getColor | ( | video::SColor & | topColor,
|  | video::SColor & | bottomColor ) const

pure virtual

Gets the color of the top and bottom vertices of the billboard.

Parameters

  [out] | topColor | Stores the color of the top vertices
  [out] | bottomColor | Stores the color of the bottom vertices

Implemented in irr::scene::IBillboardTextSceneNode.

## getSize() [1/2]

virtual const core::dimension2d< f32 > & irr::scene::IBillboardSceneNode::getSize | ( |  | ) | const

pure virtual

Returns the size of the billboard.

This will return the width of the bottom edge of the billboard. Use getWidths() to retrieve the bottom and top edges independently.

Returns
  Size of the billboard.

Implemented in irr::scene::IBillboardTextSceneNode.

## getSize() [2/2]

virtual void irr::scene::IBillboardSceneNode::getSize | ( | f32 & | height,
|  | f32 & | bottomEdgeWidth,
|  | f32 & | topEdgeWidth ) const

pure virtual

Gets the size of the the billboard and handles independent top and bottom edge widths correctly.

Parameters

  [out] | height | The height of the billboard.
  [out] | bottomEdgeWidth | The width of the bottom edge of the billboard.
  [out] | topEdgeWidth | The width of the top edge of the billboard.

## setColor() [1/2]

virtual void irr::scene::IBillboardSceneNode::setColor | ( | const video::SColor & | overallColor | ) |

pure virtual

Set the color of all vertices of the billboard.

Parameters

  [in] | overallColor | Color to set

Implemented in irr::scene::IBillboardTextSceneNode.

## setColor() [2/2]

virtual void irr::scene::IBillboardSceneNode::setColor | ( | const video::SColor & | topColor,
|  | const video::SColor & | bottomColor )

pure virtual

Set the color of the top and bottom vertices of the billboard.

Parameters

  [in] | topColor | Color to set the top vertices
  [in] | bottomColor | Color to set the bottom vertices

Implemented in irr::scene::IBillboardTextSceneNode.

## setSize() [1/2]

virtual void irr::scene::IBillboardSceneNode::setSize | ( | const core::dimension2d< f32 > & | size | ) |

pure virtual

Sets the size of the billboard, making it rectangular.

Implemented in irr::scene::IBillboardTextSceneNode.

## setSize() [2/2]

virtual void irr::scene::IBillboardSceneNode::setSize | ( | f32 | height,
|  | f32 | bottomEdgeWidth,
|  | f32 | topEdgeWidth )

pure virtual

Sets the size of the billboard with independent widths of the bottom and top edges.

Parameters

  [in] | height | The height of the billboard.
  [in] | bottomEdgeWidth | The width of the bottom edge of the billboard.
  [in] | topEdgeWidth | The width of the top edge of the billboard.

The documentation for this class was generated from the following file:

- IBillboardSceneNode.h

- Irrlicht Engine Documentation © 2003-2012 by Nikolaus Gebhardt. Generated on for Irrlicht 3D Engine by Doxygen 1.15.0